;
; For all procs:
;
; Entry:
; ------
;
; eax --> reg src
; ebx --> reg dest
; ecx --> imm32 / imm8
; edi --> BYTE *pBuffer
;
; Output:
; -------
;
; edx --> destroy
; ebx --> sometimes ebx = shl ebx, 3 (if reg src && reg dest used)
;
; Be careful:
; -----------
;
; ALL the jXxs, Call, LoopX, ... are blanks.
; You MUST call only procs before //////////x//////////x ... x//////////x//////////
;

AddRegReg:
  mov byte ptr[edi], 03h
  inc edi
  jmp AddSubXorAndOrCmpTestMovXchg

AddEaxImm32:
  mov byte ptr[edi], 05h
  inc edi
  jmp PutImm32

AddRegImm32:
  mov byte ptr[edi], 81h
  inc edi
  mov dl, 11000000b
  or edx, ebx
  call MovPtrEdiDl
  jmp PutImm32

SubRegReg:
  mov byte ptr[edi], 2Bh
  inc edi
  jmp AddSubXorAndOrCmpTestMovXchg

SubEaxImm32:
  mov byte ptr[edi], 2Dh
  inc edi
  jmp PutImm32

SubRegImm32:
  mov byte ptr[edi], 81h
  inc edi
  mov dl, 11101000b
  or edx, ebx
  call MovPtrEdiDl
  jmp PutImm32

XorRegReg:
  mov byte ptr[edi], 33h
  inc edi
  jmp AddSubXorAndOrCmpTestMovXchg

XorEaxImm32:
  mov byte ptr[edi], 35h
  inc edi
  jmp PutImm32

XorRegImm32:
  mov byte ptr[edi], 81h
  inc edi
  mov dl, 11110000b
  or edx, ebx
  call MovPtrEdiDl
  jmp PutImm32

AndRegReg:
  mov byte ptr[edi], 23h
  inc edi
  jmp AddSubXorAndOrCmpTestMovXchg

AndEaxImm32:
  mov byte ptr[edi], 25h
  inc edi
  jmp PutImm32

AndRegImm32:
  mov byte ptr[edi], 81h
  inc edi
  mov dl, 11100000b
  or edx, ebx
  call MovPtrEdiDl
  jmp PutImm32

OrRegReg:
  mov byte ptr[edi], 0Bh
  inc edi
  jmp AddSubXorAndOrCmpTestMovXchg

OrEaxImm32:
  mov byte ptr[edi], 0Dh
  inc edi
  jmp PutImm32

OrRegImm32:
  mov byte ptr[edi], 81h
  inc edi
  mov dl, 11001000b
  or edx, ebx
  call MovPtrEdiDl
  jmp PutImm32

IncReg:
  mov dl, 01000000b
  or edx, ebx
  jmp MovPtrEdiDl

DecReg:
  mov dl, 01001000b
  or edx, ebx
  jmp MovPtrEdiDl

RclReg1:
  call RclRcrRolRorShlShrSalSarReg1
  call RclReg
  ret

RclRegCl:
  call RclRcrRolRorShlShrSalSarRegCl
  call RclReg
  ret

RclRegImm8:
  call RclRcrRolRorShlShrSalSarRegImm8
  call RclReg
  jmp PutImm8

RcrReg1:
  call RclRcrRolRorShlShrSalSarReg1
  call RcrReg
  ret

RcrRegCl:
  call RclRcrRolRorShlShrSalSarRegCl
  call RcrReg
  ret

RcrRegImm8:
  call RclRcrRolRorShlShrSalSarRegImm8
  call RcrReg
  jmp PutImm8

RolReg1:
  call RclRcrRolRorShlShrSalSarReg1
  call RolReg
  ret

RolRegCl:
  call RclRcrRolRorShlShrSalSarRegCl
  call RolReg
  ret

RolRegImm8:
  call RclRcrRolRorShlShrSalSarRegImm8
  call RolReg
  jmp PutImm8

RorReg1:
  call RclRcrRolRorShlShrSalSarReg1
  call RorReg
  ret

RorRegCl:
  call RclRcrRolRorShlShrSalSarRegCl
  call RorReg
  ret

RorRegImm8:
  call RclRcrRolRorShlShrSalSarRegImm8
  call RorReg
  jmp PutImm8

ShlReg1:
  call RclRcrRolRorShlShrSalSarReg1
  call ShlReg
  ret

ShlRegCl:
  call RclRcrRolRorShlShrSalSarRegCl
  call ShlReg
  ret

ShlRegImm8:
  call RclRcrRolRorShlShrSalSarRegImm8
  call ShlReg
  jmp PutImm8

ShrReg1:
  call RclRcrRolRorShlShrSalSarReg1
  call ShrReg
  ret

ShrRegCl:
  call RclRcrRolRorShlShrSalSarRegCl
  call ShrReg
  ret

ShrRegImm8:
  call RclRcrRolRorShlShrSalSarRegImm8
  call ShrReg
  jmp PutImm8

SalReg1:
  call RclRcrRolRorShlShrSalSarReg1
  call SalReg
  ret

SalRegCl:
  call RclRcrRolRorShlShrSalSarRegCl
  call SalReg
  ret

SalRegImm8:
  call RclRcrRolRorShlShrSalSarRegImm8
  call SalReg
  jmp PutImm8

SarReg1:
  call RclRcrRolRorShlShrSalSarReg1
  call SarReg
  ret

SarRegCl:
  call RclRcrRolRorShlShrSalSarRegCl
  call SarReg
  ret

SarRegImm8:
  call RclRcrRolRorShlShrSalSarRegImm8
  call SarReg
  jmp PutImm8

MulReg:
  mov byte ptr[edi], 0F7h
  inc edi
  mov dl, 11100000b
  or edx, eax
  jmp MovPtrEdiDl

DivReg:
  mov byte ptr[edi], 0F7h
  inc edi
  mov dl, 11110000b
  or edx, eax
  jmp MovPtrEdiDl

NegReg:
  mov byte ptr[edi], 0F7h
  inc edi
  mov dl, 11011000b
  or edx, ebx
  jmp MovPtrEdiDl

NotReg:
  mov byte ptr[edi], 0F7h
  inc edi
  mov dl, 11010000b
  or edx, ebx
  jmp MovPtrEdiDl

CmpRegReg:
  mov byte ptr[edi], 3Bh
  inc edi
  jmp AddSubXorAndOrCmpTestMovXchg

CmpEaxImm32:
  mov byte ptr[edi], 3Dh
  inc edi
  jmp PutImm32

CmpRegImm32:
  mov byte ptr[edi], 81h
  inc edi
  mov dl, 11111000b
  or edx, ebx
  call MovPtrEdiDl
  jmp PutImm32

TestRegReg:
  mov byte ptr[edi], 85h
  inc edi
  jmp AddSubXorAndOrCmpTestMovXchg

TestEaxImm32:
  mov byte ptr[edi], 0A9h
  inc edi
  jmp PutImm32

TestRegImm32:
  mov byte ptr[edi], 0F7h
  inc edi
  mov dl, 11000000b
  or edx, ebx
  call MovPtrEdiDl
  jmp PutImm32

MovRegReg:
  mov byte ptr[edi], 8Bh
  inc edi
  jmp AddSubXorAndOrCmpTestMovXchg

MovRegImm32:
  mov dl, 10111000b
  or edx, ebx
  call MovPtrEdiDl
  jmp PutImm32

XchgEaxReg:
  mov dl, 10010000b
  or edx, eax
  jmp MovPtrEdiDl

XchgRegReg:
  mov byte ptr[edi], 87h
  inc edi
  jmp AddSubXorAndOrCmpTestMovXchg

PushReg:
  mov dl, 01010000b
  or edx, eax
  jmp MovPtrEdiDl

PushImm32:
  mov byte ptr[edi], 68h
  inc edi
  jmp PutImm32

PopReg:
  mov dl, 01011000b
  or edx, ebx
  jmp MovPtrEdiDl

_Pushf:
  mov byte ptr[edi], 9Ch
  inc edi
  ret

_Popf:
  mov byte ptr[edi], 9Dh
  inc edi
  ret

_Pusha:
  mov byte ptr[edi], 60h
  inc edi
  ret

_Popa:
  mov byte ptr[edi], 61h
  inc edi
  ret

_Clc:
  mov byte ptr[edi], 0F8h
  inc edi
  ret

_Stc:
  mov byte ptr[edi], 0F9h
  inc edi
  ret

_Nop:
  mov byte ptr[edi], 90h
  inc edi
  ret

_Int03:
  mov byte ptr[edi], 0CCh
  inc edi
  ret

_Ret:
  mov byte ptr[edi], 0C3h
  inc edi
  ret

_Loop:
  mov word ptr[edi], 00E2h
  inc edi
  inc edi
  ret

_Loopnz:
  mov word ptr[edi], 00E0h
  inc edi
  inc edi
  ret

_Loopz:
  mov word ptr[edi], 00E1h
  inc edi
  inc edi
  ret

_Call:
  mov byte ptr[edi], 0E8h
  inc edi
  xor ecx, ecx
  jmp PutImm32

_Jmp:
  mov word ptr[edi], 00EBh
  inc edi
  inc edi
  ret

_Jcxz:
  mov word ptr[edi], 0E367h
  inc edi
  inc edi
  xor ecx, ecx
  jmp PutImm8

_Jo:
  mov word ptr[edi], 0070h
  inc edi
  inc edi
  ret

_Jno:
  mov word ptr[edi], 0071h
  inc edi
  inc edi
  ret

_Jb:
  mov word ptr[edi], 0072h
  inc edi
  inc edi
  ret

_Jnb:
  mov word ptr[edi], 0073h
  inc edi
  inc edi
  ret

_Jz:
  mov word ptr[edi], 0074h
  inc edi
  inc edi
  ret

_Jnz:
  mov word ptr[edi], 0075h
  inc edi
  inc edi
  ret

_Jbe:
  mov word ptr[edi], 0076h
  inc edi
  inc edi
  ret

_Jnbe:
  mov word ptr[edi], 0077h
  inc edi
  inc edi
  ret

_Js:
  mov word ptr[edi], 0078h
  inc edi
  inc edi
  ret

_Jns:
  mov word ptr[edi], 0079h
  inc edi
  inc edi
  ret

_Jp:
  mov word ptr[edi], 007Ah
  inc edi
  inc edi
  ret

_Jnp:
  mov word ptr[edi], 007Bh
  inc edi
  inc edi
  ret

_Jl:
  mov word ptr[edi], 007Ch
  inc edi
  inc edi
  ret

_Jnl:
  mov word ptr[edi], 007Dh
  inc edi
  inc edi
  ret

_Jle:
  mov word ptr[edi], 007Eh
  inc edi
  inc edi
  ret

_Jnle:
  mov word ptr[edi], 007Fh
  inc edi
  inc edi
  ret

;//////////x//////////x//////////x//////////x//////////x//////////x//////////x//////////
;//////////x//////////x//////////x//////////x//////////x//////////x//////////x//////////

AddSubXorAndOrCmpTestMovXchg:
  shl ebx, 3
  mov dl, 11000000b
  or edx, eax
  or edx, ebx
MovPtrEdiDl:
  mov byte ptr[edi], dl
  inc edi
  ret

PutImm32:
  mov [edi], ecx
  add edi, 4
  ret

PutImm8:
  mov byte ptr[edi], cl
  inc edi
  ret

RclReg:
  mov dl, 11010000b
  or edx, ebx
  jmp MovPtrEdiDl

RcrReg:
  mov dl, 11011000b
  or edx, ebx
  jmp MovPtrEdiDl

RolReg:
  mov dl, 11000000b
  or edx, ebx
  jmp MovPtrEdiDl

RorReg:
  mov dl, 11001000b
  or edx, ebx
  jmp MovPtrEdiDl

ShlReg:
  mov dl, 11100000b
  or edx, ebx
  jmp MovPtrEdiDl

ShrReg:
  mov dl, 11101000b
  or edx, ebx
  jmp MovPtrEdiDl

SalReg:
  mov dl, 11110000b
  or edx, ebx
  jmp MovPtrEdiDl

SarReg:
  mov dl, 11111000b
  or edx, ebx
  jmp MovPtrEdiDl

RclRcrRolRorShlShrSalSarReg1:
  mov byte ptr[edi], 0D1h
  inc edi
  ret

RclRcrRolRorShlShrSalSarRegCl:
  mov byte ptr[edi], 0D3h
  inc edi
  ret

RclRcrRolRorShlShrSalSarRegImm8:
  mov byte ptr[edi], 0C1h
  inc edi
  ret


